//
//  Preferences.swift
//  Lockdown
//
//  Created by Don McBrien on 05/04/2021.
//

import Foundation
import SwiftUI
import Combine

struct Preferences {
   @AppStorage("Model_String") var string: String = "Jack"
   @AppStorage("Model_Real") var realNumber: Double = 6.5
   @AppStorage("Model_Probability") var probability = 0.5
   @AppStorage("Model_Integer") var integer: Int = -6
   
   @AppStorage("Model_IntArray") private var encodedIntArray: Data = try! JSONEncoder().encode([1,2,3])
   var intArray: [Int] {
      get { try! JSONDecoder().decode(Array<Int>.self, from: encodedIntArray) }
      set { encodedIntArray = try! JSONEncoder().encode(newValue) }
   }
   
   @AppStorage("Model_DoubleArray") private var encodedDoubleArray: Data = try! JSONEncoder().encode([1.1,2.2,3.3])
   var doubleArray: [Double] {
      get { try! JSONDecoder().decode(Array<Double>.self, from: encodedDoubleArray) }
      set { encodedDoubleArray = try! JSONEncoder().encode(newValue) }
   }
   
   @AppStorage("Model_ClosedRange") private var encodedClosedRange = try! JSONEncoder().encode(0...4)
   var closedRange: ClosedRange<Int> {
      get { try! JSONDecoder().decode(ClosedRange<Int>.self, from: encodedClosedRange) }
      set { encodedClosedRange = try! JSONEncoder().encode(newValue) }
   }

   func run() {
      print("Running ...")
      print("Model_String: ", self.string)
      print("Model_Real: ", self.realNumber)
      print("Model_Probability: ", self.probability)
      print("Model_Integer: ", self.integer)
      print("Model_IntArray: ", self.intArray)
      print("Model_DoubleArray: ", self.doubleArray)
      print("Model_ClosedRange: ", self.closedRange)
   }
}
