//
//  PreferencesViewModel.swift
//  Lockdown
//
//  Created by Don McBrien on 05/04/2021.
//

import Foundation
import SwiftUI

class PreferencesViewModel: ObservableObject {
   @Published private var model = Preferences()

   func runModel() { model.run() }

   var string: String {
      get { model.string }
      set { model.string = newValue }
   }

   var number: Double {
      get { model.realNumber }
      set { model.realNumber = newValue }
   }
   
   var probability: Probability {
      get { Probability(model.probability) }
      set { model.probability = newValue.value }
   }
   
   var integer: Int {
      get { model.integer }
      set { model.integer = newValue }
   }

   var intArray: [Int] {
      get { model.intArray }
      set { model.intArray = newValue }
   }

   var doubleArray: [Double] {
      get { model.doubleArray }
      set { model.doubleArray = newValue }
   }
}


